Imports System.Data.SqlClient
Imports System.IO

Public Class HomePage
    Inherits System.Web.UI.Page
    Protected WithEvents lblCityState As System.Web.UI.WebControls.Label
    Protected WithEvents lblTemperature As System.Web.UI.WebControls.Label
    Protected WithEvents lblConditions As System.Web.UI.WebControls.Label
    Protected WithEvents lblHumidity As System.Web.UI.WebControls.Label
    Protected WithEvents tblHeadlines As System.Web.UI.HtmlControls.HtmlTable
    Protected WithEvents imgGraphic As System.Web.UI.HtmlControls.HtmlImage
    Protected WithEvents rptArticles As Repeater
    Protected WithEvents rptStocks As Repeater
    Private RowCount As Integer = 0
    Private SS As StockService.DelayedStockQuote
#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
      Dim db As New Database()
      Dim dr As SqlDataReader = db.GetDataReader("sp_GetUserByID " & User.Identity.Name)

      RetrieveWeather(dr("ZipCode"))
      RetrieveNews()
      dr.Close()
      RetrieveStocks(db)

    End Sub

    Private Sub RetrieveWeather(ByVal ZipCode As String)
      Dim cs As New ZipCodeService.ZipCode()
      Dim ws As New WeatherService.WeatherRetriever()
      Dim wi As WeatherService.CurrentWeather = ws.GetWeather(ZipCode)
      Try
        lblCityState.Text = cs.ZipCodeToCityState(ZipCode)(0)
      Catch e As Exception
        lblCityState.Text = "ZIP Code " & ZipCode
      End Try
      imgGraphic.Src = wi.IconUrl
      lblTemperature.Text = wi.CurrentTemp.ToString("#0") & "&deg; F"
      lblConditions.Text = wi.Conditions
      lblHumidity.Text = (wi.Humidity * 100).ToString("#0") & "%"
      cs = Nothing
      ws = Nothing
      wi = Nothing
    End Sub

    Private Sub RetrieveNews()
      Dim ds As New DataSet()

      Dim ns As New NewsService.GetCustomNews()
      Dim strNews As String = ns.GetCustomNews("AP")
      Dim fn As String = Server.MapPath("news" + DateTime.Now.ToString("yyyymmdd-hhmmss") + ".xml")
      Dim sr As New StreamWriter(fn, False)
      sr.Write(strNews)
      sr.Close()
      ds.ReadXml(fn)
      File.Delete(fn)

      Dim dt As DataTable = ds.Tables(0)
      Dim i As Integer
      Dim dtLimited As DataTable

      If dt.Rows.Count > 10 Then
        dtLimited = ds.Tables(0).Clone()
        For i = 0 To 9
          dtLimited.ImportRow(dt.Rows(i))
        Next
        rptArticles.DataSource = dtLimited.DefaultView
        rptArticles.DataBind()
      Else
        rptArticles.DataSource = ds.Tables(0).DefaultView
        rptArticles.DataBind()
      End If
    End Sub

    Private Sub RetrieveStocks(ByVal db As Database)
      Dim strStocks As String
      Dim alStockInfo As New ArrayList()
      Dim sd As StockService.QuoteData
      Dim md As MyStockData
      SS = New StockService.DelayedStockQuote()
      Dim dr As SqlDataReader = db.GetDataReader("sp_GetUserStocks " & User.Identity.Name, True)
      Do While dr.Read()
        sd = SS.GetQuote(dr("pkStockID"), "0")
        md = New MyStockData(sd)
        alStockInfo.Add(md)
      Loop
      If alStockInfo.Count = 0 Then
        rptStocks.Visible = False
      Else
        rptStocks.DataSource = alStockInfo
        rptStocks.DataBind()
      End If
      dr.Close()
    End Sub

End Class
